<template>
  <Card>
    <div class="flex flex-between flex-middle history_header">
      <div>
        <BSwitch
          @change="(val)=>change('wins', val)"
          :disabled="loading"
          :checked="wins"
          :activeText="$t('common.bets')"
          :inactiveText="$t('common.wins')"></BSwitch>
      </div>
      <button
        class="flat_btn flat_btn-dark"
        :class="{active: opened}"
        @click="openCalendar()">
        <Calendar
          :opened="opened"></Calendar>
      </button>
      <div>
        <BSwitch
          @change="(val)=>change('my', val)"
          :disabled="loading"
          :checked="my"
          :activeText="$t('common.all')"
          :inactiveText="$t('common.my')"></BSwitch>
      </div>
    </div>
    <div class="fullHistory_body">
      <DatePicker
        v-if="opened"
        :controls="controls"
        @prev="prev">{{datePickerTitle}}
      </DatePicker>
      <div :class="{'pt-40': store!=='data'}">
        <div class="table_head">
          <div class="table-tr flex flex-middle">
            <div class="table-th">{{allGames ? $t('history.winNum') : store==='byMonth' ? $t('times.month') : $t('times.day')}}</div>
            <div class="table-th">{{$t('history.all')}}</div>
            <div class="table-th">{{$t('history.wins')}}</div>
            <div class="table-th">{{$t('history.myWins')}}</div>
            <div class="table-th"><img
              src="~/static/icons/info.png"
              alt=""></div>
          </div>
        </div>
      </div>
      <HistoryFullBody
        :allGames="allGames"
        :store="store"
        ref="historyFullBody"
        :wins="wins"
        :my="my"
        :calendarOpened="opened"
        @changeData="changeData"></HistoryFullBody>
    </div>
  </Card>
</template>

<script>
  import Card from '~/components/fullHistory/components/Card';
  import BSwitch from '~/components/UI/Switch';
  import HistoryFullBody from './body';
  import Calendar from '~/components/fullHistory/calendar';
  import DatePicker from '~/components/fullHistory/components/datePicker';

  export default {
    name: "history_stats",
    data() {
      return {
        allGames: true,
        opened: false,
        controls: {
          prev: true,
          next: false
        },
        datePickerTitle: '',
        loading: false,
        store: 'data',
        dateInfo: {
          year: new Date().getFullYear(),
          month: 0,
          day: 0
        }
      }
    },
    components: {
      BSwitch,
      HistoryFullBody,
      Calendar,
      DatePicker,
      Card
    },
    computed: {
      wins: {
        get() {
          return this.$store.state.game.filters.wins;
        },
        set(val) {
          this.$store.commit('game/SET_FILTER', {
            type: 'wins',
            value: val
          })
        }
      },
      my: {
        get() {
          return this.$store.state.game.filters.my;
        },
        set(val) {
          this.$store.commit('game/SET_FILTER', {
            type: 'my',
            value: val
          })
        }
      }
    },
    methods: {
      changeData(item) {
        const component = this.$refs['historyFullBody'];
        component.clearScrollState();
        switch (this.store) {
          case 'data': {
            component.showDetails(item);
            break;
          }
          case 'byMonth': {
            this.getByMonth({component, item});
            break;
          }
          case 'byDays': {
            this.getInDays({component, item});
            break;
          }
          case 'inDays': {
            component.showDetails(item);
            break;
          }
        }
      },
      change(field, val) {
        this[field] = val;
        const component = this.$refs['historyFullBody'];
        component.clearScrollState();
        this.$nextTick(_ => {
          switch (this.store) {
            case 'data': {
              this.$refs['historyFullBody'].clearScrollState();
              this.$refs['historyFullBody'].refreshing = true;
              this.$refs['historyFullBody'].getData().finally(_ => {
                this.loading = false;
              });
              break;
            }
            case 'byMonth': {
              this.loading = false;
              this.getByYear();
              break;
            }
            case 'byDays': {
              this.loading = false;
              this.getByMonth({component, item: {}});
              break;
            }
            case 'inDays': {
              this.getInDays({component, item: {}});
              break;
            }
            default: {
              this.loading = false;
            }
          }
        });
      },
      prev() {
        const component = this.$refs['historyFullBody'];
        component.clearScrollState();
        switch (this.store) {
          case 'inDays': {
            component.clearScrollState();
            const year = this.dateInfo.year;
            const title = component.getMonth(this.dateInfo.month);
            this.datePickerTitle = `${title} ${year}`;
            component.getDataByMonth({
              year,
              month: this.dateInfo.month
            });
            this.store = 'byDays';
            break;
          }
          case 'byDays': {
            this.getByYear();
            break;
          }
          case 'byMonth': {
            this.openCalendar();
            break;
          }
        }
      },
      getByYear() {
        this.allGames = false;
        this.datePickerTitle = this.dateInfo.year;
        this.store = 'byMonth';
        this.$nextTick(_ => {
          this.$refs['historyFullBody'].clearScrollState();
          this.$refs['historyFullBody'].getDataByYear();
        });
      },
      getByMonth({component, item}) {
        this.store = 'byDays';
        if (item.month) this.dateInfo.month = item.month;
        const title = component.getMonth(this.dateInfo.month);
        const year = this.dateInfo.year;
        this.datePickerTitle = `${title} ${year}`;
        component.getDataByMonth({
          year,
          month: this.dateInfo.month
        });
      },
      getInDays({component, item}) {
        this.store = 'inDays';
        this.allGames = true;
        if (item.day) this.dateInfo.day = item.day;
        const year = this.dateInfo.year;
        const title = component.getMonth(this.dateInfo.month);
        this.datePickerTitle = `${this.dateInfo.day} ${title} ${year}`;
        component.day = year + '/' + (this.dateInfo.month) + '/' + this.dateInfo.day;
        component.getData();
      },
      openCalendar() {
        this.opened = !this.opened;
        if (this.opened) {
          this.getByYear();
        } else {
          this.allGames = true;
          this.store = 'data';
          const component = this.$refs['historyFullBody'];
          component.day = '';
          this.$nextTick(_ => component.getData());
        }
      },
    }
  }
</script>
